;/*
; * usb_cdc.inc
; *
; *  Created: 23.02.2016 18:45:41
; *   Author: Dominik Koch
; */ 
.ifndef USB_CDC_INCLUDE
.set USB_CDC_INCLUDE = 1

.DSEG
.IF USB_CDC_ENABLE == 1
	CDC_LINE_CODING:
		dwDTERate:		.BYTE 4
		bCharFormat:	.BYTE 1
		bParityType:	.BYTE 1
		bDataBits:		.BYTE 1
	CDC_LINE_CODING_END:
	CDC_LINE_TMP:		.BYTE 1
	
	CDC_STATUS: .BYTE 1
	.SET CDC_TX_bp = 0
	.SET CDC_TX_bm = 0x01
	.SET CDC_RX_bp = 1
	.SET CDC_RX_bm = 0x02
	.SET CDC_ECHO_DISABLE_bp = 2
	.SET CDC_ECHO_DISABLE_bm = 0x04
	.SET CDC_SEND_ECHO_bp = 3
	.SET CDC_SEND_ECHO_bm = 0x08

	CDC_OUT_BUFFER_COUNT:
		.BYTE 1
	CDC_OUT_BUFFER:
		.BYTE ((EP_CDC_D_SIZE * 2)+1)
	CDC_OUT_BUFFER_END:
	

	CDC_DATA_POS:
		CDC_DATA_POSL: .BYTE 1
		CDC_DATA_POSH: .BYTE 1
	CDC_DATA:
		.BYTE CDC_DATA_SIZE
	CDC_DATA_END:
.ENDIF
.CSEG

;##################################################
;
;##################################################
USB_CDC_INIT:
	PUSH R16
	PUSH XL
	PUSH XH
		LDI R16, 0x40
		STS dwDTERate+0, R16
		LDI R16, 0x38
		STS dwDTERate+1, R16
		LDI R16, 0x00
		STS dwDTERate+2, R16
		LDI R16, 0x00
		STS dwDTERate+3, R16

		LDI R16, 0b00000001
		STS bCharFormat+0, R16

		LDI R16, 0b00000000
		STS bParityType+0, R16
	
		LDI R16, 8
		STS bDataBits+0, R16

		LDI R16, 0x00
		STS CDC_STATUS, R16

		STS  CDC_DATA_POSL, R16
		STS  CDC_DATA_POSH, R16
	POP XH
	POP XL
	POP R16
RET
;##################################################
;
;##################################################
USB_CDC_SEND_ENCAPSULATED_COMMAND:
/*
	PUSH ZL
	PUSH ZH
	PUSH R16
	PUSH R17
		LDS R16, CDC_RESPONSE_AVAILABLE
		CPI R16, 0x01
		BREQ USB_CDC_SEND_ENCAPSULATED_COMMAND_RESPONSE_AVAILABLE
		RJMP USB_CDC_SEND_ENCAPSULATED_COMMAND_RESPONSE_AVAILABLE_END
		USB_CDC_SEND_ENCAPSULATED_COMMAND_RESPONSE_AVAILABLE:
			LDI R16, 0x00
			STS CDC_RESPONSE_AVAILABLE, R16

			LDI R16, 0b10100001
			STS EP0_BUFFER+0, R16
			LDI R16, 0x01 ; RESPONSE_AVAILABLE
			STS EP0_BUFFER+1, R16
			LDI R16, 0
			STS EP0_BUFFER+2, R16
			LDI R16, 0
			STS EP0_BUFFER+3, R16
			LDI R16, 0	; Interface
			STS EP0_BUFFER+4, R16
			LDI R16, 0
			STS EP0_BUFFER+5, R16
			LDI R16, 0
			STS EP0_BUFFER+6, R16
			LDI R16, 0
			STS EP0_BUFFER+7, R16

			LDI ZL, 0x08
			LDI ZH, 0x00
			CALL USB_EP0_SEND ; Z = Size	

			RJMP USB_CDC_SEND_ENCAPSULATED_COMMAND_END
		USB_CDC_SEND_ENCAPSULATED_COMMAND_RESPONSE_AVAILABLE_END:
		; Else Send ZLP
		LDI ZL, 0x08
		LDI ZH, 0x00
		CALL USB_EP0_SEND ; Z = Size	
USB_CDC_SEND_ENCAPSULATED_COMMAND_END:
	POP R17
	POP R16
	POP ZH
	POP ZL
*/
RET
;##################################################
;
;##################################################
USB_CDC_GET_ENCAPSULATED_RESPONSE:
	; Send ZLP
	RCALL USB_EP0_SEND_ZLP
RET
;##################################################
;
;##################################################
USB_CDC_SET_LINE_CODING:
PUSH XL
PUSH XH
PUSH R16
		LDS R16, UEINTX
		CBR R16, (1<<RXOUTI)
		STS UEINTX, R16

		USB_CDC_SET_LINE_CODING_WAIT_OUT:
			LDS R16, UEINTX
			SBRS R16, RXOUTI
		RJMP USB_CDC_SET_LINE_CODING_WAIT_OUT
		USB_CDC_SET_LINE_CODING_WAIT_OUT_END:

		LDI XL, LOW(CDC_LINE_CODING)
		LDI XH, HIGH(CDC_LINE_CODING)
		RCALL USB_DATA_TO_RAM ; X = RAM_Pointer | Return = R0 = Byte Counter

		LDS R16, UEINTX
		CBR R16, (1<<RXOUTI)
		STS UEINTX, R16

		; Send ZLP
		RCALL USB_EP0_SEND_ZLP
POP R16
POP XH
POP XL
RET
;##################################################
;
;##################################################
USB_CDC_GET_LINE_CODING:
PUSH XL
PUSH XH
PUSH ZL
PUSH ZH
PUSH R16
	LDI ZL, LOW(CDC_LINE_CODING)
	LDI ZH, HIGH(CDC_LINE_CODING)
	LD  R16, Z+
	STS UEDATX, R16
	LD  R16, Z+
	STS UEDATX, R16
	LD  R16, Z+
	STS UEDATX, R16
	LD  R16, Z+
	STS UEDATX, R16
	LD  R16, Z+
	STS UEDATX, R16
	LD  R16, Z+
	STS UEDATX, R16
	LD  R16, Z+
	STS UEDATX, R16

	LDI XH, HIGH(CDC_LINE_CODING_END - CDC_LINE_CODING)
	LDI XL, LOW(CDC_LINE_CODING_END - CDC_LINE_CODING)

	RCALL USB_EP0_SEND
POP R16
POP ZH
POP ZL
POP XH
POP XL
RET
;##################################################
;
;##################################################
USB_CDC_STATUS_CLREAR_TX:
PUSH R16
	LDS R16, CDC_STATUS
	CBR R16, CDC_TX_bm
	STS CDC_STATUS, R16
USB_CDC_STATUS_CLREAR_TX_END:
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_STATUS_CLEAR_RX:
PUSH R16
PUSH ZL
PUSH ZH
	LDS R16, CDC_STATUS
	CBR R16, CDC_RX_bm
	STS CDC_STATUS, R16
USB_CDC_STATUS_CLEAR_RX_END:
POP ZH
POP ZL
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_STATUS_SET_TX:
PUSH R16
	LDS R16, CDC_STATUS
	SBR R16, CDC_TX_bm
	STS CDC_STATUS, R16
USB_CDC_STATUS_SET_TX_END:
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_STATUS_SET_RX:
PUSH R16
	LDS R16, CDC_STATUS
	SBR R16, CDC_RX_bm
	STS CDC_STATUS, R16
USB_CDC_STATUS_SET_RX_END:
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_TX_WAIT:
PUSH R16
		RCALL USB_CDC_STATUS_SET_TX
		USB_CDC_TX_WAIT_LOOP:
			LDS R16, CDC_STATUS	
			SBRC R16, CDC_TX_bp
			RJMP USB_CDC_TX_WAIT_LOOP
		USB_CDC_TX_WAIT_LOOP_END:
USB_CDC_TX_WAIT_END:
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_RX_WAIT:
PUSH R16
		RCALL USB_CDC_STATUS_SET_RX
		USB_CDC_RX_WAIT_LOOP:
			LDS R16, CDC_STATUS	
			SBRC R16, CDC_RX_bp
			RJMP USB_CDC_RX_WAIT_LOOP
		USB_CDC_RX_WAIT_LOOP_END:
USB_CDC_RX_WAIT_END:
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_DISABLE_ECHO:
PUSH R16
	LDS R16, CDC_STATUS
	SBR R16, CDC_ECHO_DISABLE_bm
	STS CDC_STATUS, R16
USB_CDC_DISABLE_ECHO_END:
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_ENABLE_ECHO:
PUSH R16
	LDS R16, CDC_STATUS
	CBR R16, CDC_ECHO_DISABLE_bm
	STS CDC_STATUS, R16
USB_CDC_ENABLE_ECHO_END:
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_SEND_ECHO:
PUSH R16
PUSH R17
PUSH XL
PUSH XH
PUSH YL
PUSH YH
PUSH ZL
PUSH ZH
	LDS R16, CDC_STATUS
	CBR R16, CDC_SEND_ECHO_bm
	STS CDC_STATUS, R16

	LDI ZL, LOW(CDC_OUT_BUFFER)
	LDI ZH, HIGH(CDC_OUT_BUFFER)

	USB_CDC_SEND_ECHO_LOOP:	;Nach 0x0D (\r) Suchen 
		LD R16, Z+ 
		CPI R16, 0x00
		BREQ USB_CDC_SEND_ECHO_LOOP_END
		CPI R16, 0x0D
	BRNE USB_CDC_SEND_ECHO_LOOP
		MOVW X, Z ;Position von Z in X Speichern
		LDI R16, 0x0A
	USB_CDC_SEND_ECHO_LOOP2: ;0x0A (\n) einfgen und alles um 1 Byte nach Rechts schieben
		LD R17, Z
		ST Z+, R16
		MOV R16, R17
		
		CPI R16, 0x00
	BRNE USB_CDC_SEND_ECHO_LOOP2
		ST Z, R16

		;Zu sendende Bytes um 1 erhhen
		LDS R16, CDC_OUT_BUFFER_COUNT
		INC R16
		STS CDC_OUT_BUFFER_COUNT, R16

		;Gespeicherte Position in X nach Z verschieben und um 1 erhhen
		MOVW Z, X
		ADIW Z, 1
	RJMP USB_CDC_SEND_ECHO_LOOP
	USB_CDC_SEND_ECHO_LOOP_END:

	RCALL USB_CDC_TX_WAIT

USB_CDC_SEND_ECHO_END:
POP ZH
POP ZL
POP YH
POP YL
POP XH
POP XL
POP R17
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_DATA_CLEAR:
PUSH R16
PUSH ZL
PUSH ZH
PUSH XL
PUSH XH
	CLR R16
	LDI XL, LOW(CDC_DATA_SIZE)
	LDI XH, HIGH(CDC_DATA_SIZE)

	STS CDC_DATA_POSL, R16
	STS CDC_DATA_POSH, R16

	LDI ZL, LOW(CDC_DATA)
	LDI ZH, HIGH(CDC_DATA)

	USB_CDC_DATA_CLEAR_LOOP1:
		ST Z+, R16
		SBIW X, 1
	BRNE USB_CDC_DATA_CLEAR_LOOP1
USB_CDC_DATA_CLEAR_END:
POP XH
POP XL
POP ZH
POP ZL
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_CONCAT_TO_DATA:
PUSH R16
PUSH R17
PUSH YL
PUSH YH
PUSH XL
PUSH XH
PUSH ZL
PUSH ZH
	LDI YL, LOW(CDC_DATA)
	LDI YH, HIGH(CDC_DATA)

	LDS XL, CDC_DATA_POSL
	LDS XH, CDC_DATA_POSH
	
	LDI ZL, LOW(CDC_OUT_BUFFER)
	LDI ZH, HIGH(CDC_OUT_BUFFER)

	ADD YL, XL
	ADC YH, XH

	LDS R16, CDC_OUT_BUFFER_COUNT
	CLR R17
	TST R16
	BREQ USB_CDC_CONCAT_TO_DATA_END

	ADD XL, R16
	ADC XH, R17

	LDI R16, LOW(CDC_DATA_SIZE)
	LDI R17, HIGH(CDC_DATA_SIZE)

	CP  XL, R16
	CPC XH, R17
	BRSH USB_CDC_CONCAT_TO_DATA_END

	STS CDC_DATA_POSL, XL
	STS CDC_DATA_POSH, XH

	LDS R17, UEBCLX
	USB_CDC_CONCAT_TO_DATA_LOOP:
		LD R16, Z+	
		ST Y+, R16
		DEC R17
	BRNE USB_CDC_CONCAT_TO_DATA_LOOP
	USB_CDC_CONCAT_TO_DATA_LOOP_END:

	CLR R16
	ST Y, R16
USB_CDC_CONCAT_TO_DATA_END:
POP ZH
POP ZL
POP XH
POP XL
POP YH
POP YL
POP R17
POP R16
RET

.endif