;/*
; * usb_cdc_cmd.inc
; *
; *  Created: 12.03.2016 18:32:14
; *   Author: Dominik Koch
; */ 
 .ifndef USB_CDC_CMD_INCLUDE
.set USB_CDC_CMD_INCLUDE = 1

.DSEG
	CMD_STRUKT:
		CMD_ARGS_MAX:		.BYTE 1
		CMD_ARGS_COUNT:		.BYTE 1
		CMD_ARGX_POINTERL:	.BYTE 1
		CMD_ARGX_POINTERH:	.BYTE 1
		CMD_LINE:			.BYTE 128 
	CMD_STRUKT_END:
.CSEG

;##################################################
;
;##################################################
USB_CDC_CMD_TEST_ENTER: ; Return = POS = R1:R0 
PUSH R16
PUSH R17
PUSH R18
PUSH YL
PUSH YH
PUSH XL
PUSH XH
	CLR R0
	CLR R1

	CLR XL
	CLR XH

	LDI YL, LOW(CDC_DATA)
	LDI YH, HIGH(CDC_DATA)

	LDS R16, CDC_DATA_POSL
	LDS R17, CDC_DATA_POSH
	
	CLR R18
	CP  R16, R18
	CPC R17, R18
	BREQ USB_CDC_CMD_TEST_ENTER_END

	; ADD 1
	LDI R18, 0x01
	ADD R16, R18
	CLR R18
	ADC R17, R18

	; Find first 0x0D Enter
	USB_CDC_CMD_TEST_ENTER_SEARCH_LOOP:
		LD R18, Y+
		ADIW X, 1
		CP  XL, R16
		CPC XH, R17
		BRSH USB_CDC_CMD_TEST_ENTER_END

		CPI R18, 0x0D
	BRNE USB_CDC_CMD_TEST_ENTER_SEARCH_LOOP
	USB_CDC_CMD_TEST_ENTER_SEARCH_LOOP_END:
		LD R18, Y
		CPI R18, 0x0A
		BREQ USB_CDC_CMD_TEST_ENTER_ADD_1_X

		RJMP USB_CDC_CMD_TEST_ENTER_ADD_1_X_END
		USB_CDC_CMD_TEST_ENTER_ADD_1_X:
			ADIW X, 1
		USB_CDC_CMD_TEST_ENTER_ADD_1_X_END:

		MOVW R1:R0, X
USB_CDC_CMD_TEST_ENTER_END:
POP XH
POP XL
POP YH
POP YL
POP R18
POP R17
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_CMD_LINE_DEL: ; X = RAM_DATA_POINTER, Y = LINE_END_POS 
PUSH R16
PUSH ZL
PUSH ZH
PUSH YL
PUSH YH
PUSH XL
PUSH XH
	LDS ZL, CDC_DATA_POSL
	LDS ZH, CDC_DATA_POSH
	
	SUB ZL, YL
	SBC ZH, YH

	STS CDC_DATA_POSL, ZL
	STS CDC_DATA_POSH, ZH

	MOVW Z, X
	ADD ZL, YL
	ADC ZH, YH

	USB_CDC_CMD_LINE_DEL_LOOP:
		LD R16, Z+
		ST X+, R16
		CPI R16, 0x00
	BRNE USB_CDC_CMD_LINE_DEL_LOOP
USB_CDC_CMD_LINE_DEL_END:
POP XH
POP XL
POP YH
POP YL
POP ZH
POP ZL
POP R16
RET
;##################################################
;
;##################################################
.set CKEY_NONE		=	 0x00
.set CKEY_UP		=	 0x01
.set CKEY_Down		=	 0x02
.set CKEY_Left		=	 0x03
.set CKEY_Right		=	 0x04
.set CKEY_Backspace =	 0x05
.set CKEY_ENTF		=	 0x06
.set CKEY_TAB		=	 0x07
;-----------------
.set CKEY_F1		=	 0x10
.set CKEY_F2		=	 0x11
.set CKEY_F3		=	 0x12
.set CKEY_F4		=	 0x13
.set CKEY_F5		=	 0x14
.set CKEY_F6		=	 0x15
.set CKEY_F7		=	 0x16
.set CKEY_F8		=	 0x17
.set CKEY_F9		=	 0x18
.set CKEY_F10		=	 0x19
.set CKEY_F11		=	 0x1A
.set CKEY_F12		=	 0x1B
;-----------------
.set CKEY_EINFG		=	 0x20
.set CKEY_POS1		=	 0x21
.set CKEY_END		=	 0x22
.set CKEY_Bild_UP	=	 0x23
.set CKEY_Bild_Down =	 0x24
;-------------------
USB_CDC_TEST_CONTROL_CHAR:	;X = RAM_POINTER | RETURN = R0
PUSH R16
PUSH R17
PUSH R18
PUSH ZL
PUSH ZH
PUSH YL
PUSH YH
PUSH XL
PUSH XH
	CLR R18
	LD R16, X+
	
	; Test vor TAB
	CPI R16, 0x09
	BREQ CONTROL_CHAR_TAB	
	
	; Test vor Backspace
	CPI R16, 0x7F
	BREQ CONTROL_CHAR_BACKSPACE

	LDI R17, 0x1B
	CP  R16, R17
	LD  R16, X+
	LDI R17, 0x5B
	CPC R16, R17
	BREQ CONTROL_CHAR_LOOP1

	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	CONTROL_CHAR_LOOP1:
		LD R16, X+

		CPI R16, 0x41 ; Up Key
		BREQ CONTROL_CHAR_KEY_UP

		CPI R16, 0x42 ; Down Key
		BREQ CONTROL_CHAR_KEY_DOWN

		CPI R16, 0x43 ; Right Key
		BREQ CONTROL_CHAR_KEY_RIGHT

		CPI R16, 0x44 ; Left Key
		BREQ CONTROL_CHAR_KEY_LEFT

		CPI R16, 0x31
		BREQ CONTROL_CHAR_LOOP2

	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	CONTROL_CHAR_LOOP1_END:

	RJMP CONTROL_CHAR_LOOP2_END
	CONTROL_CHAR_LOOP2:
		LD R16, X+
		LD R17, X+

		;0x1B5B31__
		LDI R18, 0x7E

		CPI R16, 0x31 ; F1
		CPC R17, R18
		BREQ CONTROL_CHAR_F1_F12

		CPI R16, 0x32 ; F2
		CPC R17, R18
		BREQ CONTROL_CHAR_F1_F12

		CPI R16, 0x33 ; F3
		CPC R17, R18
		BREQ CONTROL_CHAR_F1_F12

		CPI R16, 0x34 ; F4
		CPC R17, R18
		BREQ CONTROL_CHAR_F1_F12

		CPI R16, 0x35 ; F5
		CPC R17, R18
		BREQ CONTROL_CHAR_F1_F12

		CLR R18
	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	CONTROL_CHAR_LOOP2_END:

	;------------------------------------------
	CONTROL_CHAR_TAB:
		LDI R18, CKEY_TAB
	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	;------------------------------------------
	CONTROL_CHAR_BACKSPACE:
		LDI R18, CKEY_Backspace
	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	;------------------------------------------
	CONTROL_CHAR_KEY_UP:
		LDI R18, CKEY_UP
	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	;------------------------------------------
	CONTROL_CHAR_KEY_DOWN:
		LDI R18, CKEY_Down
	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	;------------------------------------------
	CONTROL_CHAR_KEY_LEFT:
		LDI R18, CKEY_Left
	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	;------------------------------------------
	CONTROL_CHAR_KEY_RIGHT:
		LDI R18, CKEY_Right
	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	;------------------------------------------
	CONTROL_CHAR_F1_F12:
		LDI R18, 0x00
	RJMP USB_CDC_TEST_CONTROL_CHAR_END
	;------------------------------------------
USB_CDC_TEST_CONTROL_CHAR_END:
	MOV R0, R18
POP XH
POP XL
POP YH
POP YL
POP ZH
POP ZL
POP R18
POP R17
POP R16
RET
;##################################################
;
;##################################################
USB_CDC_LOAD_CMD: ; R1:R0 = CMD_STR_LEN | RETURN = R0 = MAX_ARGS
PUSH YL
PUSH YH
PUSH XL
PUSH XH
PUSH ZL
PUSH ZH	
	LDI ZL, LOW(CDC_DATA)
	LDI ZH, HIGH(CDC_DATA)
	LDI YL, LOW(CMD_STRUKT)
	LDI YH, HIGH(CMD_STRUKT)			
	CALL COMMAND_LINE_CONVERT ;Y = CMD_STRUKT_POINTER , Z = CMD_LINE_POINTER 

	;Lsche CMD Line from CMD_DATA
	MOVW X, Z
	MOVW Y, R0:R1
	RCALL USB_CDC_CMD_LINE_DEL ; X = RAM_DATA_POINTER, Y = LINE_END_POS 
						
	LDS R0, CMD_ARGS_MAX
POP ZH
POP ZL
POP XH
POP XL
POP YH
POP YL
RET
;##################################################
;
;##################################################
USB_CDC_EXEC_CMD: ;Z = PGM_CMP_STRING | X = Functions_Pointer | RETURN R0 = [1=True | 0=False]
PUSH YL
PUSH YH
PUSH XL
PUSH XH
PUSH ZL
PUSH ZH	
	LDS YL, CMD_ARGX_POINTERL
	LDS YH, CMD_ARGX_POINTERH
	CALL COMMAND_CMP_PGM_RAM ; Z=PGM_POINTER  Y=RAM_POINTER | Return R0 = [1=True | 0=False]

	MOVW Z, X
	SBRC R0, 0
	ICALL 
POP ZH
POP ZL
POP XH
POP XL
POP YH
POP YL
RET



.endif