;/*
; * cmd_string.inc
; *
; *  Created: 14.03.2016 17:49:04
; *   Author: Dominik Koch
; */ 

.DSEG
/*
	CMD_STRUKT:
		CMD_ARGS_MAX: .BYTE 1

		CMD_ARGS_COUNT: .BYTE 1

		CMD_ARGX_POINTERL: .BYTE 1
		CMD_ARGX_POINTERH: .BYTE 1

		CMD_LINE: .BYTE 100 
	CMD_STRUKT_END:
*/
.CSEG
;##################################################
;
;##################################################
COMMAND_GET_ARGX: ;Y = CMD_STRUKT_POINTER , R16 = COUNT
PUSH R16
PUSH R17
PUSH R18
PUSH YL
PUSH YH
PUSH ZL
PUSH ZH
	MOVW Z, Y
	ADIW Z, 4

	; Load Max Args
	LDD R17, Y+0 ;CMD_ARGS_MAXL

	CP  R16, R17
	BRSH COMMAND_GET_ARGX_END

	STD Y+1, R16

	CLR R18
	CP  R16, R18
	BREQ COMMAND_GET_ARGX_END

	COMMAND_GET_ARGX_LOOP:
		LD R18, Z+
		CPI R18, 0x00
		BRNE COMMAND_GET_ARGX_LOOP
		DEC R16
	BRNE COMMAND_GET_ARGX_LOOP

COMMAND_GET_ARGX_END:
	STD Y+2, ZL ;CMD_ARGX_POINTERL
	STD Y+3, ZH ;CMD_ARGX_POINTERH
POP ZH
POP ZL
POP YH
POP YL
POP R18
POP R17
POP R16
RET
;##################################################
;
;##################################################
COMMAND_LINE_CONVERT: ;Y = CMD_STRUKT_POINTER , Z = CMD_LINE_POINTER 
PUSH R16
PUSH R17
PUSH YL
PUSH YH
PUSH XL
PUSH XH
PUSH ZL
PUSH ZH
	CLR R16
	; Reset MAX Args
	STD Y+0, R16
	; Reset Args Count
	STD Y+1, R16
	; Reset ArgX Pointer
	STD Y+2, R16
	STD Y+3, R16

	MOVW XL:XH, YL:YH
	ADIW X, 4

	CLR R17 ; Max Args

	LD R16, Z
	CPI R16, 0x0D
	BREQ COMMAND_LINE_CONVERT_ABRUCH
	
	CPI R16, 0x00
	BREQ COMMAND_LINE_CONVERT_ABRUCH

	; Trim 0x20 from Start
	CPI R16, 0x20
	BREQ COMMAND_LINE_CONVERT_TRIM_LOOP1
	RJMP COMMAND_LINE_CONVERT_TRIM_LOOP1_END
	COMMAND_LINE_CONVERT_TRIM_LOOP1:
		LD R16, Z+
		CPI R16, 0x20
	BREQ COMMAND_LINE_CONVERT_TRIM_LOOP1
	SBIW Z, 1
	LD R16, Z
	COMMAND_LINE_CONVERT_TRIM_LOOP1_END:

	; Trim 0x0A from Start
	CPI R16, 0x0A
	BREQ COMMAND_LINE_CONVERT_TRIM_LOOP_0A
	RJMP COMMAND_LINE_CONVERT_TRIM_LOOP_0A_END
	COMMAND_LINE_CONVERT_TRIM_LOOP_0A:
		LD R16, Z+
		CPI R16, 0x0A
	BREQ COMMAND_LINE_CONVERT_TRIM_LOOP_0A
	SBIW Z, 1
	LD R16, Z
	COMMAND_LINE_CONVERT_TRIM_LOOP_0A_END:


	COMMAND_LINE_CONVERT_LOOP1:
		LD R16, Z+

		CPI R16, 0x20
		BREQ COMMAND_LINE_CONVERT_STORE2

		CPI R16, '"'
		BREQ COMMAND_LINE_CONVERT_LOOP2

		CPI R16, 0x0D
		BREQ COMMAND_LINE_CONVERT_LOOP_END

		CPI R16, 0x00
		BREQ COMMAND_LINE_CONVERT_LOOP_END

		COMMAND_LINE_CONVERT_STORE1:
			ST X+, R16
		COMMAND_LINE_CONVERT_STORE1_END:

		RJMP COMMAND_LINE_CONVERT_LOOP1
		COMMAND_LINE_CONVERT_STORE2:
			;Inc Max Args
			INC R17
			CLR R16
			ST X+, R16

			; Trim 0x20 from Start
			COMMAND_LINE_CONVERT_TRIM_LOOP2:
				LD R16, Z+
				CPI R16, 0x20
			BREQ COMMAND_LINE_CONVERT_TRIM_LOOP2
			SBIW Z, 1
		COMMAND_LINE_CONVERT_STORE2_END:
	RJMP COMMAND_LINE_CONVERT_LOOP1
	;----------------------------------------------------
	COMMAND_LINE_CONVERT_LOOP2:
		LD R16, Z+

		CPI R16, '"'
		BREQ COMMAND_LINE_CONVERT_LOOP1
		CPI R16, 0x0D
		BREQ COMMAND_LINE_CONVERT_LOOP_END
		CPI R16, 0x00
		BREQ COMMAND_LINE_CONVERT_LOOP_END

		ST X+, R16
	RJMP COMMAND_LINE_CONVERT_LOOP2
	;----------------------------------------------------
	COMMAND_LINE_CONVERT_LOOP_END:
		; NULL Terminate
		CLR R16
		ST X+, R16

		INC R17			;Inc Max Args
		STD Y+0, R17	;Save Max Args

		;Point to Arg 0
		MOVW XL:XH, YL:YH
		ADIW X, 4
		STD Y+2, XL
		STD Y+3, XH

	RJMP COMMAND_LINE_CONVERT_ABRUCH_END
	COMMAND_LINE_CONVERT_ABRUCH:
		; NULL Terminate
		CLR R16
		ST X+, R16

		CLR R17			;Inc Max Args
		STD Y+0, R17	;Save Max Args

		;Point 0
		STD Y+2, R17
		STD Y+3, R17
	COMMAND_LINE_CONVERT_ABRUCH_END:
COMMAND_LINE_CONVERT_END:
POP ZH
POP ZL
POP XH
POP XL
POP YH
POP YL
POP R17
POP R16
RET
;##################################################
;
;##################################################
COMMAND_CMP_PGM_RAM: ; Z=PGM_POINTER  Y=RAM_POINTER | Return R0 = [1=True | 0=False]
PUSH R18
PUSH R19
PUSH YL
PUSH YH
PUSH ZL
PUSH ZH
	CLR R0

	; Shift Left
	LSL ZL
	ROL ZH
	COMMAND_CMP_PGM_RAM_LOOP:
		LPM R18, Z+
		LD  R19, Y+
		CP R18, R19
		BRNE COMMAND_CMP_PGM_RAM_END
		CPI R18, 0x00
		BREQ COMMAND_CMP_PGM_RAM_LOOP_END
	RJMP COMMAND_CMP_PGM_RAM_LOOP
	COMMAND_CMP_PGM_RAM_LOOP_END:
	INC R0
COMMAND_CMP_PGM_RAM_END:
POP ZH
POP ZL
POP YH
POP YL
POP R19
POP R18
RET
;##################################################
;
;##################################################
COMMAND_COPY_PGM_TO_RAM: ; Z = PGM_POINTER , Y = RAM_POINTER
PUSH R16
PUSH YL
PUSH YH
PUSH ZL
PUSH ZH
	; Shift Left
	LSL ZL
	ROL ZH
	COMMAND_PGM_TO_RAM_LOOP:
		LPM R16, Z+
		ST  Y+, R16
		CPI R16, 0x00
	BRNE COMMAND_PGM_TO_RAM_LOOP
COMMAND_PGM_TO_RAM_END:
POP ZH
POP ZL
POP YH
POP YL
POP R16
RET
;##################################################
;
;##################################################
COMMAND_COPY_RAM_TO_RAM: ; Z = RAM_POINTER_FROM , Y = RAM_POINTER_TO, RETURN = R0 = SIZE 
PUSH R16
PUSH YL
PUSH YH
PUSH ZL
PUSH ZH
	CLR R0
	COMMAND_RAM_TO_RAM_LOOP:
		LD R16, Z+
		ST  Y+, R16
		INC R0
		BREQ COMMAND_RAM_TO_RAMEND
		CPI R16, 0x00
	BRNE COMMAND_RAM_TO_RAM_LOOP
COMMAND_RAM_TO_RAMEND:
DEC R0
POP ZH
POP ZL
POP YH
POP YL
POP R16
RET
;##################################################
;
;##################################################
